' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class MainForm
    ' ***** Insert Code Snippet #8 here.

    Private Sub ActHelpAbout_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles ActHelpAbout.Click
        ' ----- Show the About form.
        AboutProgram.ShowDialog()
    End Sub
    Private Sub ActLibraryItem_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActLibraryItem.LinkClicked
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub
    Private Sub PicLibraryItem_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicLibraryItem.Click
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub
    Private Sub ActPatronRecord_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActPatronRecord.LinkClicked
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub
    Private Sub PicPatronRecord_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicPatronRecord.Click
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub
    Private Sub ActHelp_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActHelp.LinkClicked
        ' ----- Help mode.
        TaskHelp()
    End Sub
    Private Sub PicHelp_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicHelp.Click
        ' ----- Help mode.
        TaskHelp()
    End Sub
    Private Sub ActCheckOut_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActCheckOut.LinkClicked
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub
    Private Sub PicCheckOut_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicCheckOut.Click
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub
    Private Sub ActCheckIn_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActCheckIn.LinkClicked
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub
    Private Sub PicCheckIn_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicCheckIn.Click
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub
    Private Sub ActAdmin_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActAdmin.LinkClicked
        ' ----- Administration mode.
        TaskAdmin()
    End Sub
    Private Sub PicAdmin_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicAdmin.Click
        ' ----- Administration mode.
        TaskAdmin()
    End Sub
    Private Sub ActProcess_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActProcess.LinkClicked
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub
    Private Sub PicProcess_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicProcess.Click
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub
    Private Sub ActReports_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActReports.LinkClicked
        ' ----- Print Reports mode.
        TaskReports()
    End Sub
    Private Sub PicReports_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicReports.Click
        ' ----- Print Reports mode.
        TaskReports()
    End Sub
    Private Sub TaskLibraryItem()
        ' ----- Library item task.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelLibraryItem.Visible = True
        ActLibraryItem.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicLibraryItem.Top)
        Me.AcceptButton = ActSearch

        ' ----- Get ready for a new search.
        On Error Resume Next
        SearchText.Focus()
    End Sub
    Private Sub TaskPatronRecord()
        ' ----- Patron Record mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelPatronRecord.Visible = True
        ActPatronRecord.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicPatronRecord.Top)
        Me.AcceptButton = ActAccessPatron
    End Sub
    Private Sub TaskHelp()
        ' ----- Help mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelHelp.Visible = True
        ActHelp.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicHelp.Top)
        Me.AcceptButton = Nothing
    End Sub
    Private Sub TaskCheckOut()
        ' ----- Check Out mode.

        ' ----- Update the display.
        AllPanelsInvisible()

       ' ***** Remove next source line, and then
       ' ***** Insert Code Snippet #15 here.
        PanelCheckOut.Visible = True

        ActCheckOut.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicCheckOut.Top)
        Me.AcceptButton = ActDoCheckOut
    End Sub
    Private Sub TaskCheckIn()
        ' ----- Check In mode.

        ' ----- Update the display.
        AllPanelsInvisible()

       ' ***** Remove next source line, and then
       ' ***** Insert Code Snippet #16 here.
        PanelCheckIn.Visible = True

        ActCheckIn.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicCheckIn.Top)
        Me.AcceptButton = ActDoCheckIn

        ' ----- Reset the input fields.
        CheckInDate.Value = Today
        CheckInDate.MaxDate = Today
        CheckInDate.MinDate = DateAdd(DateInterval.Day, -6, Today)
        CheckInDay.Text = "Today"
        CheckInDay.BackColor = SystemColors.Control
        CheckInDay.ForeColor = SystemColors.ControlText
        CheckInBarcode.Text = ""
        LabelCheckedIn.Visible = False
        CheckedInDetail.Visible = False
        CheckedInDetail.Text = "No information available."
        CheckInBarcode.Focus()
    End Sub
    Private Sub TaskAdmin()
        ' ----- Administration mode.

        ' ----- Update the display.
        AllPanelsInvisible()

       ' ***** Remove next source line, and then
       ' ***** Insert Code Snippet #17 here.
        PanelAdmin.Visible = True

        ActAdmin.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicAdmin.Top)
        Me.AcceptButton = Nothing
    End Sub
    Private Sub TaskProcess()
        ' ----- Daily Processing mode.

        ' ----- Update the display.
        AllPanelsInvisible()

       ' ***** Remove next source line, and then
       ' ***** Insert Code Snippet #18 here.
        PanelProcess.Visible = True

        ActProcess.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicProcess.Top)
        Me.AcceptButton = ActDoProcess
    End Sub
    Private Sub TaskReports()
        ' ----- Print Reports mode.

        ' ----- Update the display.
        AllPanelsInvisible()

       ' ***** Remove next source line, and then
       ' ***** Insert Code Snippet #14 here.
        PanelReports.Visible = True

        ActReports.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicReports.Top)
        Me.AcceptButton = ActDoReports
    End Sub
    Private Sub MainForm_Load(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Prepare the form.

        ' ----- Adjust the various panel positions.
        PanelLibraryItem.Location = New Point( _
            TaskListBackground.Width, WelcomeBackground.Height)
        PanelPatronRecord.Location = PanelLibraryItem.Location
        PanelHelp.Location = PanelLibraryItem.Location
        PanelCheckOut.Location = PanelLibraryItem.Location
        PanelCheckIn.Location = PanelLibraryItem.Location
        PanelAdmin.Location = PanelLibraryItem.Location
        PanelProcess.Location = PanelLibraryItem.Location
        PanelReports.Location = PanelLibraryItem.Location
        PanelLibraryItem.Visible = True
        ActSearchLimits.PerformClick()

        ' ***** Insert Code Snippet #13 here.

    End Sub
    Private Sub AllPanelsInvisible()
        ' ----- Hide all work panels.
        PanelLibraryItem.Visible = False
        PanelPatronRecord.Visible = False
        PanelHelp.Visible = False
        PanelCheckOut.Visible = False
        PanelCheckIn.Visible = False
        PanelAdmin.Visible = False
        PanelProcess.Visible = False
        PanelReports.Visible = False

        ' ----- Correctly color all action labels.
        ActLibraryItem.BackColor = Color.White
        ActPatronRecord.BackColor = Color.White
        ActHelp.BackColor = Color.White
        ActCheckOut.BackColor = Color.White
        ActCheckIn.BackColor = Color.White
        ActAdmin.BackColor = Color.White
        ActProcess.BackColor = Color.White
        ActReports.BackColor = Color.White
    End Sub
    Private Sub SearchText_Enter(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles SearchText.Enter
        ' ----- Highlight the entire text.
        SearchText.SelectAll()
    End Sub
    Private Sub ActSearchLimits_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles ActSearchLimits.Click
        ' ----- Toggle the display of the media type and location fields.
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then
            ' ----- Hide the two fields.
            LabelSearchMediaType.Visible = False
            SearchMediaType.Visible = False
            LabelSearchLocation.Visible = False
            SearchLocation.Visible = False
            ActSearchClear.Location = New System.Drawing.Point(ActSearchClear.Left, _
                SearchMediaType.Top)
            ActSearchLimits.Location = New System.Drawing.Point(ActSearchLimits.Left, _
                SearchMediaType.Top)
            ActSearch.Location = New System.Drawing.Point(ActSearch.Left, _
                SearchMediaType.Top)
            ActSearchLimits.Text = "Mor&e >>"
        Else
            ' ----- Show the two fields.
            ActSearchClear.Location = New System.Drawing.Point(ActSearchClear.Left, _
                LabelMoreLimitsTop.Top)
            ActSearchLimits.Location = New System.Drawing.Point(ActSearchLimits.Left, _
                LabelMoreLimitsTop.Top)
            ActSearch.Location = New System.Drawing.Point(ActSearch.Left, _
                LabelMoreLimitsTop.Top)
            LabelSearchMediaType.Visible = True
            SearchMediaType.Visible = True
            LabelSearchLocation.Visible = True
            SearchLocation.Visible = True
            ActSearchLimits.Text = "<< L&ess"
        End If
    End Sub
    Private Sub CheckInBarcode_Enter(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles CheckInBarcode.Enter
        ' ----- Highlight the entire text.
        CheckInBarcode.SelectAll()
    End Sub
    Private Sub CheckOutBarcode_Enter(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles CheckOutBarcode.Enter
        ' ----- Highlight the entire text.
        CheckOutBarcode.SelectAll()
    End Sub
    Private Sub MainForm_KeyDown(ByVal sender As Object, _
            ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        ' ----- The keys F2 through F9 access the different sections of the form.
        Select Case (e.KeyCode)
            Case Keys.F2
                TaskLibraryItem()
                e.Handled = True
            Case Keys.F3
                TaskPatronRecord()
                e.Handled = True
            Case Keys.F4
                ' ----- Allow form to handle Alt+F4.
                If (e.Alt = True) Then
                    Me.Close()
                Else
                    TaskHelp()
                End If
                e.Handled = True
            Case Keys.F5
                TaskCheckOut()
                e.Handled = True
            Case Keys.F6
                TaskCheckIn()
                e.Handled = True
            Case Keys.F7
                TaskAdmin()
                e.Handled = True
            Case Keys.F8
                TaskProcess()
                e.Handled = True
            Case Keys.F9
                TaskReports()
                e.Handled = True

                ' ***** Insert Code Snippet #11 here

        End Select
    End Sub

    Private Sub ActLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActLogin.Click
        ' ***** Insert Code Snippet #9 here.

    End Sub

    ' ***** Insert Code Snippet #10 here.

    ' ***** Insert Code Snippet #12 here.

End Class
