' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class ItemLimit
    Public Function PromptUser() As String
        ' ----- Prompt the user for search criteria.
        Me.ShowDialog()
        If (Me.DialogResult = Windows.Forms.DialogResult.OK) Then
            If (OptionAll.Checked = True) Then
                Return "*"
            Else
                Return Trim(ItemTitle.Text)
            End If
        Else
            Return ""
        End If
    End Function

    Private Sub ItemTitle_GotFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemTitle.GotFocus
        ' ----- Highlight the entire text.
        ItemTitle.SelectAll()
    End Sub

    Private Sub ItemTitle_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemTitle.TextChanged
        ' ----- Make this a limited search.
        OptionByTitle.Checked = CBool(Trim(ItemTitle.Text) <> "")
        OptionAll.Checked = Not OptionByTitle.Checked
    End Sub

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- For name searches, require a value.
        If (OptionByTitle.Checked = True) And (Trim(ItemTitle.Text) = "") Then
            MsgBox("When searching by title, please supply a search text.", _
                MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub
End Class
