' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class MainForm
    Private Sub ActHelpAbout_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles ActHelpAbout.Click
        ' ----- Show the About form.
        AboutProgram.ShowDialog()
    End Sub
    Private Sub ActLibraryItem_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActLibraryItem.LinkClicked
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub
    Private Sub PicLibraryItem_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicLibraryItem.Click
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub
    Private Sub ActPatronRecord_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActPatronRecord.LinkClicked
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub
    Private Sub PicPatronRecord_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicPatronRecord.Click
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub
    Private Sub ActHelp_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActHelp.LinkClicked
        ' ----- Help mode.
        TaskHelp()
    End Sub
    Private Sub PicHelp_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicHelp.Click
        ' ----- Help mode.
        TaskHelp()
    End Sub
    Private Sub ActCheckOut_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActCheckOut.LinkClicked
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub
    Private Sub PicCheckOut_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicCheckOut.Click
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub
    Private Sub ActCheckIn_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActCheckIn.LinkClicked
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub
    Private Sub PicCheckIn_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicCheckIn.Click
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub
    Private Sub ActAdmin_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActAdmin.LinkClicked
        ' ----- Administration mode.
        TaskAdmin()
    End Sub
    Private Sub PicAdmin_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicAdmin.Click
        ' ----- Administration mode.
        TaskAdmin()
    End Sub
    Private Sub ActProcess_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActProcess.LinkClicked
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub
    Private Sub PicProcess_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicProcess.Click
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub
    Private Sub ActReports_LinkClicked(ByVal sender As System.Object, _
            ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
            Handles ActReports.LinkClicked
        ' ----- Print Reports mode.
        TaskReports()
    End Sub
    Private Sub PicReports_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles PicReports.Click
        ' ----- Print Reports mode.
        TaskReports()
    End Sub
    Private Sub TaskLibraryItem()
        ' ----- Library item task.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelLibraryItem.Visible = True
        ActLibraryItem.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicLibraryItem.Top)
        Me.AcceptButton = ActSearch

        ' ----- Get ready for a new search.
        ActSearchClear.PerformClick()
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then _
            ActSearchLimits.PerformClick()
        On Error Resume Next
        SearchText.Focus()
    End Sub
    Private Sub TaskPatronRecord()
        ' ----- Patron Record mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelPatronRecord.Visible = True
        ActPatronRecord.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicPatronRecord.Top)
        Me.AcceptButton = ActAccessPatron
    End Sub
    Private Sub TaskHelp()
        ' ----- Help mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelHelp.Visible = True
        ActHelp.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicHelp.Top)
        Me.AcceptButton = Nothing
    End Sub
    Private Sub TaskCheckOut()
        ' ----- Check Out mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.CheckOutItems)) Then _
            PanelCheckOut.Visible = True
        ActCheckOut.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicCheckOut.Top)
        Me.AcceptButton = ActDoCheckOut
    End Sub
    Private Sub TaskCheckIn()
        ' ----- Check In mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.CheckInItems)) Then _
            PanelCheckIn.Visible = True
        ActCheckIn.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicCheckIn.Top)
        Me.AcceptButton = ActDoCheckIn

        ' ----- Reset the input fields.
        CheckInDate.Value = Today
        CheckInDate.MaxDate = Today
        CheckInDate.MinDate = DateAdd(DateInterval.Day, -6, Today)
        CheckInDay.Text = "Today"
        CheckInDay.BackColor = SystemColors.Control
        CheckInDay.ForeColor = SystemColors.ControlText
        CheckInBarcode.Text = ""
        LabelCheckedIn.Visible = False
        CheckedInDetail.Visible = False
        CheckedInDetail.Text = "No information available."
        CheckInBarcode.Focus()
    End Sub
    Private Sub TaskAdmin()
        ' ----- Administration mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.AdminFeatures)) Then _
            PanelAdmin.Visible = True
        ActAdmin.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicAdmin.Top)
        Me.AcceptButton = Nothing
    End Sub
    Private Sub TaskProcess()
        ' ----- Daily Processing mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.DailyProcessing)) Then _
            PanelProcess.Visible = True
        ActProcess.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicProcess.Top)
        Me.AcceptButton = ActDoProcess
    End Sub
    Private Sub TaskReports()
        ' ----- Print Reports mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        If (SecurityProfile(LibrarySecurity.RunReports)) Then _
            PanelReports.Visible = True
        ActReports.BackColor = SystemColors.Control
        LabelSelected.Location = New System.Drawing.Point(LabelSelected.Left, _
            PicReports.Top)
        Me.AcceptButton = ActDoReports
    End Sub
    Private Sub MainForm_Load(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Prepare the form.
        Dim sqlText As String
        Dim dbInfo As SqlClient.SqlDataReader

        On Error GoTo ErrorHandler

        ' ----- Adjust the various panel positions.
        PanelLibraryItem.Location = New Point( _
            TaskListBackground.Width, WelcomeBackground.Height)
        PanelPatronRecord.Location = PanelLibraryItem.Location
        PanelHelp.Location = PanelLibraryItem.Location
        PanelCheckOut.Location = PanelLibraryItem.Location
        PanelCheckIn.Location = PanelLibraryItem.Location
        PanelAdmin.Location = PanelLibraryItem.Location
        PanelProcess.Location = PanelLibraryItem.Location
        PanelReports.Location = PanelLibraryItem.Location
        PanelLibraryItem.Visible = True
        ActSearchLimits.PerformClick()

        ' ----- Load in the list of search types.
        SearchType.Items.Add(New ListItemData("Lookup By Title", LookupMethods.ByTitle))
        SearchType.SelectedIndex = 0
        SearchType.Items.Add(New ListItemData("Lookup By Author", _
            LookupMethods.ByAuthor))
        SearchType.Items.Add(New ListItemData("Lookup By Subject", _
            LookupMethods.BySubject))
        SearchType.Items.Add(New ListItemData("Lookup By Keyword (Match Any)", _
            LookupMethods.ByKeywordAny))
        SearchType.Items.Add(New ListItemData("Lookup By Keyword (Match All)", _
            LookupMethods.ByKeywordAll))
        SearchType.Items.Add(New ListItemData("Lookup By Publisher", _
            LookupMethods.ByPublisher))
        SearchType.Items.Add(New ListItemData("Lookup By Series Name", _
            LookupMethods.BySeries))
        SearchType.Items.Add(New ListItemData("Lookup By Barcode", _
            LookupMethods.ByBarcode))

        ' ----- Load in the media types.
        SearchMediaType.Items.Add(New ListItemData("<All Media Types>", -1))
        SearchMediaType.SelectedIndex = 0
        sqlText = "SELECT ID, FullName FROM CodeMediaType ORDER BY FullName"
        dbInfo = CreateReader(sqlText)
        Do While dbInfo.Read
            SearchMediaType.Items.Add(New ListItemData(CStr(dbInfo!FullName), _
                CInt(dbInfo!ID)))
        Loop
        dbInfo.Close()

        ' ----- Load in the locations.
        SearchLocation.Items.Add(New ListItemData("<All Locations>", -1))
        SearchLocation.SelectedIndex = 0
        sqlText = "SELECT ID, FullName FROM CodeLocation ORDER BY FullName"
        dbInfo = CreateReader(sqlText)
        Do While dbInfo.Read
            SearchLocation.Items.Add(New ListItemData(CStr(dbInfo!FullName), _
                CInt(dbInfo!ID)))
        Loop
        dbInfo.Close()

        ' ----- Prepare for a patron user.
        UpdateDisplayForUser()
        Return

ErrorHandler:
        GeneralError("MainForm.MainForm_Load", Err.GetException())
        Resume Next
    End Sub
    Private Sub AllPanelsInvisible()
        ' ----- Hide all work panels.
        PanelLibraryItem.Visible = False
        PanelPatronRecord.Visible = False
        PanelHelp.Visible = False
        PanelCheckOut.Visible = False
        PanelCheckIn.Visible = False
        PanelAdmin.Visible = False
        PanelProcess.Visible = False
        PanelReports.Visible = False

        ' ----- Correctly color all action labels.
        ActLibraryItem.BackColor = Color.White
        ActPatronRecord.BackColor = Color.White
        ActHelp.BackColor = Color.White
        ActCheckOut.BackColor = Color.White
        ActCheckIn.BackColor = Color.White
        ActAdmin.BackColor = Color.White
        ActProcess.BackColor = Color.White
        ActReports.BackColor = Color.White
    End Sub
    Private Sub SearchText_Enter(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles SearchText.Enter
        ' ----- Highlight the entire text.
        SearchText.SelectAll()
    End Sub
    Private Sub ActSearchLimits_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles ActSearchLimits.Click
        ' ----- Toggle the display of the media type and location fields.
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then
            ' ----- Hide the two fields.
            LabelSearchMediaType.Visible = False
            SearchMediaType.Visible = False
            LabelSearchLocation.Visible = False
            SearchLocation.Visible = False
            ActSearchClear.Location = New System.Drawing.Point(ActSearchClear.Left, _
                SearchMediaType.Top)
            ActSearchLimits.Location = New System.Drawing.Point(ActSearchLimits.Left, _
                SearchMediaType.Top)
            ActSearch.Location = New System.Drawing.Point(ActSearch.Left, _
                SearchMediaType.Top)
            ActSearchLimits.Text = "Mor&e >>"
        Else
            ' ----- Show the two fields.
            ActSearchClear.Location = New System.Drawing.Point(ActSearchClear.Left, _
                LabelMoreLimitsTop.Top)
            ActSearchLimits.Location = New System.Drawing.Point(ActSearchLimits.Left, _
                LabelMoreLimitsTop.Top)
            ActSearch.Location = New System.Drawing.Point(ActSearch.Left, _
                LabelMoreLimitsTop.Top)
            LabelSearchMediaType.Visible = True
            SearchMediaType.Visible = True
            LabelSearchLocation.Visible = True
            SearchLocation.Visible = True
            ActSearchLimits.Text = "<< L&ess"
        End If
    End Sub
    Private Sub CheckInBarcode_Enter(ByVal sender As Object, _
            ByVal e As System.EventArgs) Handles CheckInBarcode.Enter
        ' ----- Highlight the entire text.
        CheckInBarcode.SelectAll()
    End Sub
    Private Sub CheckOutBarcode_Enter(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles CheckOutBarcode.Enter
        ' ----- Highlight the entire text.
        CheckOutBarcode.SelectAll()
    End Sub
    Private Sub MainForm_KeyDown(ByVal sender As Object, _
            ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        ' ----- The keys F2 through F9 access the different sections of the form.
        Select Case (e.KeyCode)
            Case Keys.F2
                TaskLibraryItem()
                e.Handled = True
            Case Keys.F3
                TaskPatronRecord()
                e.Handled = True
            Case Keys.F4
                ' ----- Allow form to handle Alt+F4.
                If (e.Alt = True) Then
                    Me.Close()
                Else
                    TaskHelp()
                End If
                e.Handled = True
            Case Keys.F5
                TaskCheckOut()
                e.Handled = True
            Case Keys.F6
                TaskCheckIn()
                e.Handled = True
            Case Keys.F7
                TaskAdmin()
                e.Handled = True
            Case Keys.F8
                TaskProcess()
                e.Handled = True
            Case Keys.F9
                TaskReports()
                e.Handled = True
            Case Keys.F12
                ' ----- Prompt the user for patron or administrative mode.
                ShowLoginForm()
                e.Handled = True
        End Select
    End Sub

    Private Sub AdminLinkBarcodeLabel_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkBarcodeLabel.LinkClicked
        ' ----- Let the user edit the list of barcode labels.
        If (SecurityProfile(LibrarySecurity.ManageBarcodeTemplates) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New Library.BarcodeLabel)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkBarcodePage_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkBarcodePage.LinkClicked
        ' ----- Let the user edit the list of barcode pages.
        If (SecurityProfile(LibrarySecurity.ManageBarcodeTemplates) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New Library.BarcodePage)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkGroups_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkGroups.LinkClicked
        ' ----- Let the user edit the list of security groups.
        If (SecurityProfile(LibrarySecurity.ManageGroups) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New Library.GroupName)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkUsers_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkUsers.LinkClicked
        ' ----- Let the user edit the list of administrative users.
        If (SecurityProfile(LibrarySecurity.ManageUsers) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Edit the records.
        ListEditRecords.ManageRecords(New Library.UserName)
        ListEditRecords = Nothing
    End Sub

    Private Sub ActLogin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActLogin.Click
        ' ----- Prompt the user for patron or administrative mode.
        ShowLoginForm()
    End Sub

    Private Sub ShowLoginForm()
        ' ----- Prompt the user for patron or administrative mode.
        Dim userChoice As Windows.Forms.DialogResult
        userChoice = ChangeUser.ShowDialog()
        ChangeUser = Nothing
        If (userChoice = Windows.Forms.DialogResult.OK) Then UpdateDisplayForUser()
    End Sub

    Private Sub UpdateDisplayForUser()
        ' ----- Update the display based on the user settings.
        Dim sqlText As String

        If (LoggedInUserID = -1) Then
            ' ----- Set up the display for patron mode.
            ActiveMode.Text = "Welcome Library Patron"

            LabelTasks.Visible = False
            LineTasks.Visible = False
            PicCheckOut.Visible = False
            ActCheckOut.Visible = False
            PicCheckIn.Visible = False
            ActCheckIn.Visible = False
            PicAdmin.Visible = False
            ActAdmin.Visible = False
            PicProcess.Visible = False
            ActProcess.Visible = False
            PicReports.Visible = False
            ActReports.Visible = False

            ' ----- Show or hide the Login button per the settings.
            ActLogin.Visible = Not My.Settings.HideLogin

            ' ----- Lookup items by default.
            TaskLibraryItem()
        Else
            ' ----- Set up the display for administrative mode.
            Try
                sqlText = "SELECT FullName FROM UserName WHERE ID = " & LoggedInUserID
                ActiveMode.Text = "Administrative User: " & CStr(ExecuteSQLReturn(sqlText))
            Catch ex As Exception
                GeneralError("MainForm.UpdateDisplayForUser", Err.GetException())
                ActiveMode.Text = "Administrative User: Unknown"
            End Try

            LabelTasks.Visible = True
            LineTasks.Visible = True
            PicCheckOut.Visible = True
            ActCheckOut.Visible = True
            PicCheckIn.Visible = True
            ActCheckIn.Visible = True
            PicAdmin.Visible = True
            ActAdmin.Visible = True
            PicProcess.Visible = True
            ActProcess.Visible = True
            PicReports.Visible = True
            ActReports.Visible = True
            ActLogin.Visible = True
        End If
    End Sub

    Private Sub AdminLinkItems_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkItems.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageItems) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of items.
        ListEditRecords.ManageRecords(New Library.NamedItem)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkAuthors_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkAuthors.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageAuthors) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of authors.
        ListEditRecords.ManageRecords(New Library.Author)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkAuthorTypes_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkAuthorTypes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageAuthorTypes) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of author types.
        ListEditRecords.ManageRecords(New Library.CodeAuthorType)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPublishers_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkPublishers.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePublishers) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of publishers.
        ListEditRecords.ManageRecords(New Library.Publisher)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkSeries_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkSeries.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageSeries) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of series.
        ListEditRecords.ManageRecords(New Library.CodeSeries)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkMediaTypes_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkMediaTypes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageMediaTypes) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of media types.
        ListEditRecords.ManageRecords(New Library.CodeMediaType)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkStatusCodes_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkStatusCodes.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageCopyStatus) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of copy status codes.
        ListEditRecords.ManageRecords(New Library.CodeCopyStatus)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkLocations_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkLocations.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageLocations) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of locations.
        ListEditRecords.ManageRecords(New Library.CodeLocation)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkHolidays_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkHolidays.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageHolidays) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of holidays.
        ListEditRecords.ManageRecords(New Library.Holiday)
        ListEditRecords = Nothing

        ' ----- Reload the holidays if they changed.
        RefreshHolidays()
    End Sub

    Private Sub AdminLinkPatrons_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkPatrons.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePatrons) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of patrons.
        ListEditRecords.ManageRecords(New Library.Patron)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkPatronGroups_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkPatronGroups.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManagePatronGroups) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Let the user edit the list of patron groups.
        ListEditRecords.ManageRecords(New Library.CodePatronGroup)
        ListEditRecords = Nothing
    End Sub

    Private Sub AdminLinkValues_LinkClicked(ByVal sender As Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles AdminLinkValues.LinkClicked
        ' ----- Make sure the user is allowed to do this.
        If (SecurityProfile(LibrarySecurity.ManageValues) = False) Then
            MsgBox(NotAuthorizedMessage, MsgBoxStyle.OkOnly Or _
                MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If

        ' ----- Access the maintenance portion of the program.
        Maintenance.ShowDialog()
    End Sub

    Private Sub ActDoReports_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActDoReports.Click
        ' ----- Show the reports form.
        ReportSelect.ShowDialog()
    End Sub

    Private Sub SearchType_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SearchType.SelectedIndexChanged
        ' ----- Update the search hints.
        Select Case CInt(CType(SearchType.SelectedItem, ListItemData))
            Case LookupMethods.ByTitle
                LabelSearchHintsData.Text = "Enter a title or partial title in the " & _
                    "Search Text field. You may include the asterisk character ( * ) " & _
                    "as a wildcard character."
            Case LookupMethods.ByAuthor
                LabelSearchHintsData.Text = "Enter an author name or partial author " & _
                    "name in the Search Text field. You may include the asterisk " & _
                    "character ( * ) as a wildcard character. Enter the name in " & _
                    "last name, first name format, separated by a comma. You may omit " & _
                    "the last name or first name if needed."
            Case LookupMethods.BySubject
                LabelSearchHintsData.Text = "Enter a subject or partial subject in the " & _
                    "Search Text field. You may include the asterisk character ( * ) " & _
                    "as a wildcard character."
            Case LookupMethods.ByKeywordAny
                LabelSearchHintsData.Text = "Enter one or more keywords in the " & _
                    "Search Text field, separated by commas. Note that wildcard " & _
                    "characters are not permitted in keyword searches. Items that " & _
                    "match any one of the keywords will be returned."
            Case LookupMethods.ByKeywordAll
                LabelSearchHintsData.Text = "Enter one or more keywords in the " & _
                    "Search Text field, separated by commas. Note that wildcard " & _
                    "characters are not permitted in keyword searches. Only items " & _
                    "that match all of the keywords will be returned."
            Case LookupMethods.ByPublisher
                LabelSearchHintsData.Text = "Enter a publisher name or partial " & _
                    "publisher name in the Search Text field. You may include " & _
                    "the asterisk character ( * ) as a wildcard character."
            Case LookupMethods.BySeries
                LabelSearchHintsData.Text = "Enter a series name or partial " & _
                    "series name in the Search Text field. You may include " & _
                    "the asterisk character ( * ) as a wildcard character."
            Case LookupMethods.ByBarcode
                LabelSearchHintsData.Text = "Enter a numeric barcode for a library " & _
                    "item in the Search Text field. Note that wildcard characters " & _
                    "are not allowed in barcode searches."
            Case LookupMethods.ByDatabaseID
                LabelSearchHintsData.Text = "Enter a numeric database ID for a library " & _
                    "item in the Search Text field. Note that wildcard characters " & _
                    "are not allowed in database ID searches."
        End Select
    End Sub

    Private Sub ActSearchClear_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ActSearchClear.Click
        ' ----- Clear the current search criteria.
        SearchType.SelectedIndex = SearchType.Items.IndexOf(CInt(LookupMethods.ByTitle))
        SearchText.Text = ""
        SearchMediaType.SelectedIndex = SearchMediaType.Items.IndexOf(-1)
        SearchLocation.SelectedIndex = SearchLocation.Items.IndexOf(-1)
    End Sub

    Private Sub ActSearch_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ActSearch.Click
        ' ----- The user wants to lookup some items.
        Dim mediaLimit As Integer
        Dim locationLimit As Integer
        Dim searchMethod As Integer

        ' ----- Make sure the user supplied valid search criteria.
        searchMethod = CInt(CType(SearchType.SelectedItem, ListItemData))
        Select Case searchMethod
            Case LookupMethods.ByTitle, LookupMethods.BySubject, _
                    LookupMethods.ByPublisher, LookupMethods.BySeries
                ' ----- A search text is required.
                If (Trim(SearchText.Text) = "") Then
                    MsgBox("Please supply a search text.", MsgBoxStyle.OkOnly Or _
                        MsgBoxStyle.Exclamation, ProgramTitle)
                    SearchText.Focus()
                    Return
                End If
            Case LookupMethods.ByAuthor
                ' ----- A search text with a maximum of one comma is required.
                If (CountSubStr(SearchText.Text, ",") >= 2) Or _
                        (Trim(SearchText.Text) = "") Then
                    MsgBox("Please supply a search text with a maximum of one comma.", _
                        MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
                    SearchText.Focus()
                    Return
                End If

                ' ----- Make sure at least one name component is supplied.
                If (Trim(GetSubStr(SearchText.Text, ",", 1)) = "") And _
                        (Trim(GetSubStr(SearchText.Text, ",", 2)) = "") Then
                    MsgBox("Please supply at least one name component.", _
                        MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
                    SearchText.Focus()
                    Return
                End If
            Case LookupMethods.ByKeywordAny, LookupMethods.ByKeywordAll
                ' ----- A search text is required.
                If (Trim(SearchText.Text) = "") Then
                    MsgBox("Please supply a search text.", MsgBoxStyle.OkOnly Or _
                        MsgBoxStyle.Exclamation, ProgramTitle)
                    SearchText.Focus()
                    Return
                End If

                ' ----- Make sure that no wildcards are included.
                If (InStr(SearchText.Text, "*") > 0) Then
                    MsgBox("Wildcard characters (*) are not permitted in " & _
                        "keyword searches.", MsgBoxStyle.OkOnly Or _
                        MsgBoxStyle.Exclamation, ProgramTitle)
                    SearchText.Focus()
                    Return
                End If
            Case LookupMethods.ByBarcode, LookupMethods.ByDatabaseID
                ' ----- A numeric search text is required.
                If (DigitsOnly(SearchText.Text) <> Trim(SearchText.Text)) Or _
                        (Trim(SearchText.Text) = "") Then
                    MsgBox("Please supply a numeric search text.", MsgBoxStyle.OkOnly Or _
                        MsgBoxStyle.Exclamation, ProgramTitle)
                    SearchText.Focus()
                    Return
                End If
        End Select

        ' ----- Get the extended criteria if needed.
        mediaLimit = -1
        locationLimit = -1
        If (SearchMediaType.Visible = True) Then
            mediaLimit = CInt(CType(SearchMediaType.SelectedItem, ListItemData))
            locationLimit = CInt(CType(SearchLocation.SelectedItem, ListItemData))
        End If

        ' ----- Initiate the search.
        Call (New ItemLookup).InitiateSearch( _
            CType(searchMethod, Library.LookupMethods), _
            Trim(SearchText.Text), mediaLimit, locationLimit)
    End Sub

    Private Sub ActAccessPatron_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ActAccessPatron.Click
        ' ***** Insert Code Snippet #12 here.

    End Sub
End Class
