' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class PatronLimit
    Public Function PromptUser() As String
        ' ----- Prompt the user for search criteria.
        Me.ShowDialog()
        If (Me.DialogResult = Windows.Forms.DialogResult.OK) Then
            If (OptionAll.Checked = True) Then
                Return "*"
            Else
                Return Trim(ItemName.Text)
            End If
        Else
            Return ""
        End If
    End Function

    Private Sub ItemName_Enter(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemName.Enter
        ' ----- Highlight the entire text.
        ItemName.SelectAll()
    End Sub

    Private Sub ItemName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ItemName.TextChanged
        ' ----- Make this a limited search.
        OptionByName.Checked = CBool(Trim(ItemName.Text) <> "")
        OptionAll.Checked = Not OptionByName.Checked
    End Sub

    Private Sub ActOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActOK.Click
        ' ----- For name searches, require a value.
        If (OptionByName.Checked = True) And (Trim(ItemName.Text) = "") Then
            MsgBox("When searching by name, please supply a search text.", _
                MsgBoxStyle.OkOnly Or MsgBoxStyle.Exclamation, ProgramTitle)
            Return
        End If
        Me.DialogResult = Windows.Forms.DialogResult.OK
    End Sub
End Class
