Public Class Form1

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        ' ----- Force a redraw.
        PictureBox1.Invalidate()
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        ' ----- Draw the blank background.
        e.Graphics.Clear(SystemColors.Window)
        e.Graphics.DrawRectangle(SystemPens.InactiveCaption, 0, 0, _
            PictureBox1.Width - 1, PictureBox1.Height - 1)

        ' ----- Change the orientation of the display.
        Dim saveState As Drawing2D.GraphicsState = e.Graphics.Save()
        Dim mirrorMatrix As New Drawing2D.Matrix(1, 0, 0, -1, 0, PictureBox1.Height)
        e.Graphics.Transform = mirrorMatrix

        ' ----- Draw the text.
        e.Graphics.DrawString(TextBox1.Text, TextBox1.Font, _
            SystemBrushes.WindowText, 1, 4)

        ' ----- Put everything back.
        e.Graphics.Restore(saveState)
    End Sub
End Class
