' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Imports System.Data

Partial Class Statistics
    Inherits System.Web.UI.Page

    Public LibraryDB As System.Data.SqlClient.SqlConnection

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----- Prepare the data for the report.
        Dim sqlText As String
        Dim reportData As Collections.Generic.List(Of BoundSchemaStatistics)
        Dim oneEntry As BoundSchemaStatistics
        Dim resultValue As Integer
        Dim counter As Integer
        Dim tableSets() As String = {"Author", "Publisher", "Subject", _
            "NamedItem", "ItemCopy", "Patron"}
        Dim tableTitles() As String = {"Authors", "Publishers", "Subject Headings", _
            "Items", "Item Copies", "Patrons"}

        ' ----- Connect to the database.
        LibraryDB = New SqlClient.SqlConnection( _
            ConfigurationManager.ConnectionStrings( _
            "LibraryConnection").ConnectionString)
        LibraryDB.Open()

        ' ----- Build the report data. It's all counts from different tables.
        reportData = New Collections.Generic.List(Of BoundSchemaStatistics)
        For counter = 0 To UBound(tableSets)
            ' ----- Process one table.
            sqlText = "SELECT COUNT(*) FROM " & tableSets(counter)
            resultValue = CInt(ExecuteSQLReturn(sqlText, LibraryDB))

            ' ----- Add it to the report data.
            oneEntry = New BoundSchemaStatistics
            oneEntry.EntryName = tableTitles(counter)
            oneEntry.EntryValue = CStr(resultValue)
            reportData.Add(oneEntry)
        Next counter

        ' ----- Finished with the connection.
        LibraryDB.Close()

        StatisticsGrid.DataSource = reportData
        StatisticsGrid.DataBind()
    End Sub
End Class
