' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class BaseCodeForm
    Public Overridable Function AddRecord() As Integer
        ' ----- Prompt to add a new record. Return the ID
        '       when added, or -1 if cancelled.
        Return -1
    End Function

    Public Overridable Function CanUserAdd() As Boolean
        ' ----- Check the security of current user to see
        '       if adding is allowed.
        Return False
    End Function

    Public Overridable Function CanUserEdit() As Boolean
        ' ----- Check the security of this current to see
        '       if editing is allowed.
        Return False
    End Function

    Public Overridable Function CanUserDelete() As Boolean
        ' ----- Check the security of this current to see
        '       if deleting is allowed.
        Return False
    End Function

    Public Overridable Function DeleteRecord( _
            ByVal recordID As Integer) As Boolean
        ' ----- Prompt the user to delete a record.
        '       Return True on delete.
        Return False
    End Function

    Public Overridable Function EditRecord( _
            ByVal recordID As Integer) As Integer
        ' ----- Prompt the user to edit the record. Return the
        '       record's ID if saved, or -1 on cancel.
        Return -1
    End Function

    Public Overridable Sub FillListWithRecords( _
            ByRef destList As ListBox, ByRef exceededMatches As Boolean)
        ' ----- Fill a ListBox control with existing records.
    End Sub

    Public Overridable Function FormatRecordName( _
            ByVal recordID As Integer) As String
        ' ----- Return the formatted name of a single record.
        Return ""
    End Function

    Public Overridable Function GetEditDescription() As String
        ' ----- Return a description of this editor.
        Return ""
    End Function

    Public Overridable Function GetEditTitle() As String
        ' ----- Return the title-bar text for this editor.
        Return ""
    End Function

    Public Overridable Sub SearchForRecord( _
            ByRef destList As ListBox, _
            ByRef exceededMatches As Boolean)
        ' ----- Prompt the user to search for a record.
        Return
    End Sub

    Public Overridable Function UsesSearch() As Boolean
        ' ----- Does this editor support searching?
        Return False
    End Function
End Class