' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Public Class ReportSchemaPatronItems
    ' ----- Used for the following reports:
    '         Report #1: Items checked out report
    '         Report #2: Items overdue report
    '         Report #3: Items missing report
    Private StoredPatronName As String
    Private StoredPatronBarcode As String
    Private StoredDueDate As Date
    Private StoredCopyNumber As Integer
    Private StoredItemBarcode As String
    Private StoredTitle As String
    Private StoredMediaName As String

    Public Property PatronName() As String
        Get
            Return StoredPatronName
        End Get
        Set(ByVal value As String)
            StoredPatronName = value
        End Set
    End Property

    Public Property PatronBarcode() As String
        Get
            Return StoredPatronBarcode
        End Get
        Set(ByVal value As String)
            StoredPatronBarcode = value
        End Set
    End Property

    Public Property DueDate() As Date
        Get
            Return StoredDueDate
        End Get
        Set(ByVal value As Date)
            StoredDueDate = value
        End Set
    End Property

    Public Property CopyNumber() As Integer
        Get
            Return StoredCopyNumber
        End Get
        Set(ByVal value As Integer)
            StoredCopyNumber = value
        End Set
    End Property

    Public Property ItemBarcode() As String
        Get
            Return StoredItemBarcode
        End Get
        Set(ByVal value As String)
            StoredItemBarcode = value
        End Set
    End Property

    Public Property Title() As String
        Get
            Return StoredTitle
        End Get
        Set(ByVal value As String)
            StoredTitle = value
        End Set
    End Property

    Public Property MediaName() As String
        Get
            Return StoredMediaName
        End Get
        Set(ByVal value As String)
            StoredMediaName = value
        End Set
    End Property
End Class

Public Class ReportSchemaPatronFines
    ' ----- Used for the following reports:
    '         Report #4: Fines owed by patron
    Private StoredPatronName As String
    Private StoredPatronBarcode As String
    Private StoredFinesDue As Decimal

    Public Property PatronName() As String
        Get
            Return StoredPatronName
        End Get
        Set(ByVal value As String)
            StoredPatronName = value
        End Set
    End Property

    Public Property PatronBarcode() As String
        Get
            Return StoredPatronBarcode
        End Get
        Set(ByVal value As String)
            StoredPatronBarcode = value
        End Set
    End Property

    Public Property FinesDue() As Decimal
        Get
            Return StoredFinesDue
        End Get
        Set(ByVal value As Decimal)
            StoredFinesDue = value
        End Set
    End Property
End Class

Public Class ReportSchemaStatistics
    ' ----- Used for the following reports:
    '         Report #5: Library database statistics report
    Private StoredEntryName As String
    Private StoredEntryValue As String

    Public Property EntryName() As String
        Get
            Return StoredEntryName
        End Get
        Set(ByVal value As String)
            StoredEntryName = value
        End Set
    End Property

    Public Property EntryValue() As String
        Get
            Return StoredEntryValue
        End Get
        Set(ByVal value As String)
            StoredEntryValue = value
        End Set
    End Property
End Class
