Namespace My

    'The following events are available for MyApplication
    '
    'Startup: Raised when the application starts, before the startup form is created.
    'Shutdown: Raised after all application forms are closed.  This event is not raised if the application is terminating abnormally.
    'UnhandledException: Raised if the application encounters an unhandled exception.
    'StartupNextInstance: Raised when launching a single-instance application and the application is already active. 
    'NetworkAvailabilityChanged: Raised when the network connection is connected or disconnected.

    Class MyApplication
        Private Sub MyApplication_Startup(ByVal sender As Object, ByVal e As Microsoft.VisualBasic.ApplicationServices.StartupEventArgs) Handles Me.Startup
            ' ----- Display the splash form for at least 3 seconds.
            My.Application.MinimumSplashScreenDisplayTime = 3000
        End Sub

        Private Sub MyApplication_StartupNextInstance(ByVal sender As Object, _
              ByVal e As Microsoft.VisualBasic.ApplicationServices.StartupNextInstanceEventArgs) _
              Handles Me.StartupNextInstance
            ' ----- Force the main form to the front.
            My.Application.MainForm.Activate()
        End Sub

        ' ***** Insert Code Snippet #4 here.

    End Class
End Namespace
