' ----- The Library Project
'       Start-to-Finish Visual Basic 2005
'       Copyright (c) 2006 by Tim Patrick

Imports System.Data

Partial Class _Default
    Inherits System.Web.UI.Page

    Public LibraryDB As System.Data.SqlClient.SqlConnection

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' ----- Prepare the page.
        Dim sqlText As String
        Dim dbInfo As SqlClient.SqlDataReader

        ' ----- Initialize the media type list, but only the first time through.
        If (Page.IsPostBack = False) Then
            ' ----- Add in the unselected item.
            SearchMediaType.Items.Add(New WebControls.ListItem("<All Types>", "-1"))
            SearchMediaType.SelectedIndex = 0

            ' ----- Connect to the database.
            LibraryDB = New SqlClient.SqlConnection( _
                ConfigurationManager.ConnectionStrings( _
                "LibraryConnection").ConnectionString)
            LibraryDB.Open()

            ' ----- Load in the media types.
            sqlText = "SELECT ID, FullName FROM CodeMediaType ORDER BY FullName"
            dbInfo = CreateReader(sqlText, LibraryDB)
            Do While dbInfo.Read
                SearchMediaType.Items.Add(New WebControls.ListItem( _
                    CStr(dbInfo!FullName), CStr(dbInfo!ID)))
            Loop
            dbInfo.Close()

            ' ----- Finished with the connection.
            LibraryDB.Close()
        End If
    End Sub
End Class
