Public Class CustomReport

    Private Sub CustomReport_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Link to the RDLC report design.
        Me.ReportViewer1.LocalReport.ReportEmbeddedResource = _
            "SimpleReport.Report2.rdlc"

        ' ----- Create a fake table of fake records.
        Dim fakeSource As New Collections.Generic.List(Of FakeActivityRecord)

        ' ----- Add each of the fake records.
        fakeSource.Add(New FakeActivityRecord(1, "Breakfast"))
        fakeSource.Add(New FakeActivityRecord(2, "Lunch"))
        fakeSource.Add(New FakeActivityRecord(3, "Dinner"))

        ' ----- Build a new data source. Remember, it must have
        '       the same name.
        Dim fakeReportSource As New _
            Microsoft.Reporting.WinForms.ReportDataSource
        fakeReportSource.Name = "SimpleReport_FakeActivityRecord"
        fakeReportSource.Value = fakeSource

        ' ----- Connect the data source to the report, and we're done.
        Me.ReportViewer1.LocalReport.DataSources.Add(fakeReportSource)

        Me.ReportViewer1.RefreshReport()
    End Sub
End Class